<?php
  require_once "interface/IMultilandingDB.class.php";
  class MultilandingDB implements IMultilandingDB {
  const DB_NAME = "multilanding.db";
  private $_db = null;

    function __get($name){
      if($name == "db"){
        return $this->_db;
      } else {
        throw new Exception("Неизвестное свойство!");
      }
    }

    function __construct() {

      $this->_db = new PDO('sqlite:'.dirname(__FILE__).DIRECTORY_SEPARATOR.self::DB_NAME);
      if(is_file(self::DB_NAME) and filesize(self::DB_NAME) == 0){
      try {
        $sql = "CREATE TABLE keyword(
          id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
          utm VARCHAR(255) NOT NULL,
          key VARCHAR(255) NOT NULL
        )";
        $this->_db->exec($sql);
        } catch (PDOException $e) {
            die('Ошибка при создании базы данных:' . $e->getMessage());
          }
      }
    }

    function __destruct() {
      unset($this->_db);
    }

    function saveCollection($utm, $key){
      $sql = "SELECT utm FROM keyword WHERE utm = :utm";
      $stmt = $this->_db->prepare($sql);
      $stmt->bindParam(':utm', $utm, PDO::PARAM_STR);
      $stmt->execute();
      $temp = $this->db2Arr($stmt);
      if($temp){
        return false;
      } else {
        $sql = "INSERT INTO keyword (utm, key) VALUES (:utm, :key)";
        $stmt = $this->_db->prepare($sql);
        $stmt->bindParam(':utm', $utm, PDO::PARAM_STR);
        $stmt->bindParam(':key', $key, PDO::PARAM_STR);
        return $stmt->execute();
      }
    }

    private function db2Arr($data){
      $arr = [];
      while ($row = $data->fetch(PDO::FETCH_ASSOC)){
        $arr[] = $row;
      }
      return $arr;
    }

    function getCollection(){
      $sql = "SELECT * FROM keyword ORDER BY keyword.id DESC";
      $res = $this->_db->query($sql);
      if(!$res) {
        return false;
      } else {
        return $this->db2Arr($res);
      }
    }

    function deleteCollection($id){
      $sql = "DELETE FROM keyword WHERE id = :id";
      $stmt = $this->_db->prepare($sql);
      $stmt->bindParam(':id', $id, PDO::PARAM_INT);
      return $stmt->execute();
    }

    function outputKey($utm_content){
      $sql = "SELECT key FROM keyword WHERE utm = :utm_content";
      $stmt = $this->_db->prepare($sql);
      $stmt->bindParam(':utm_content', $utm_content, PDO::PARAM_STR);
      $stmt->execute();
      return $this->db2Arr($stmt);
    }
  }
